public class Sudoku {
    public static void main(String[] args) {
        // 0 represents "blank"
        // Otherwise, each cell should be a digit between 1 and N.

        // mini size
        int[][] board = {
            {0, 0, 0, 1},
            {0, 0, 0, 3},
            {3, 0, 0, 0},
            {4, 0, 0, 0},
        };

        // "easy" difficulty normal size
        // int[][] board = {
        //     {0, 0, 0, 0, 0, 0, 0, 0, 5},
        //     {0, 1, 2, 5, 4, 0, 0, 0, 6},
        //     {0, 3, 5, 0, 1, 0, 4, 7, 0},
        //     {0, 0, 0, 0, 0, 4, 1, 6, 0},
        //     {1, 6, 4, 9, 0, 5, 7, 2, 3},
        //     {0, 7, 9, 1, 0, 0, 0, 0, 0},
        //     {0, 9, 1, 0, 6, 0, 8, 5, 0},
        //     {2, 0, 0, 0, 9, 8, 3, 4, 0},
        //     {7, 0, 0, 0, 0, 0, 0, 0, 0},
        // };
        
        // "evil" difficulty normal size
        // int[][] board = {
        //     { 0, 3, 2, 0, 0, 0, 1, 5, 0 },
        //     { 7, 0, 0, 1, 0, 0, 9, 0, 0 },
        //     { 0, 0, 0, 3, 0, 0, 7, 0, 0 },
        //     { 0, 5, 0, 0, 8, 0, 0, 0, 7 },
        //     { 0, 0, 0, 9, 0, 4, 0, 0, 0 },
        //     { 2, 0, 0, 0, 7, 0, 0, 4, 0 },
        //     { 0, 0, 4, 0, 0, 6, 0, 0, 0 },
        //     { 0, 0, 7, 0, 0, 9, 0, 0, 6 },
        //     { 0, 9, 1, 0, 0, 0, 5, 2, 0 },
        // };

        // Large puzzle. Will run "forever" without further optimizations.
        // int[][] board = {
        //     {0,0,0,0,0,1,0,5,0,0,0,0,0,0,0,0},
        //     {0,8,0,7,0,0,0,13,0,4,11,12,0,0,15,0},
        //     {14,0,0,0,0,15,0,0,0,10,0,0,0,0,16,0},
        //     {10,0,0,3,0,0,12,11,0,0,6,0,2,0,0,0},
        //     {0,0,5,0,6,13,0,16,0,7,0,0,0,0,0,14},
        //     {0,11,1,0,10,2,0,0,15,0,0,0,12,3,0,0},
        //     {0,15,13,0,0,12,0,14,0,0,9,0,1,7,4,0},
        //     {0,4,7,0,5,0,11,0,16,0,14,0,0,15,8,6},
        //     {0,0,15,0,0,0,0,0,0,6,0,0,5,13,7,0},
        //     {1,0,3,9,14,0,0,0,0,0,16,10,0,0,0,0},
        //     {0,0,0,0,0,0,16,6,5,12,0,0,0,0,9,4},
        //     {0,14,0,0,8,0,0,0,0,11,15,13,0,0,0,10},
        //     {11,0,0,0,0,0,0,0,0,0,0,0,4,12,0,9},
        //     {2,0,0,16,0,10,0,0,0,15,0,0,11,6,13,7},
        //     {6,13,0,0,0,0,0,0,9,0,0,16,15,1,0,0},
        //     {0,5,0,15,0,0,4,0,0,13,0,0,0,0,0,0},
        // };

        solve(board);
    }

    // Side length of one of the medium-sized inner boxes.
    // Square root of the board side size.
    // 2 for "mini" sudoku
    // 3 for "normal" sudoku
    // 4 for "large" 16x16 sudoku
    public static final int K = 2; 

    // Side length of the board. Should be a perfect square
    public static final int N = K * K;

    public static void solve(int[][] board) {
        solve(board, 0, 0);
    }

    // Recursively search for a solution by keeping track of row index i and column index j
    // where we know the board is filled in.
    private static void solve(int[][] board, int i, int j) {
        if (!deadEnd(board)) {  // This check is needed in base case and 
                                // recursive case, so move it up here.
            if (i >= N) {
                // base case: we're past the last row, that means it's solved!
                printBoard(board);
            } else {
                // recursive case: guess the next cell value.
                if (board[i][j] == 0) {
                    // This cell is blank. Time to guess.
                    
                    // TODO: implement

                } else {
                    // This cell is not blank. Do nothing and continue to the next cell.

                    // TODO: implement
                }
            }
        }
    }

    // Check if the board already contains a contradiction.
    // (The same number appears twice in a single row, column, or K-by-K "box".)
    private static boolean deadEnd(int[][] board) {
        return !rowsOk(board) || !columnsOk(board) || !boxesOk(board);
    }

    public static void printBoard(int[][] board) {
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board.length; j++) {
                if (j > 0) {
                    System.out.print(" ");
                }
                System.out.print(board[i][j]);
            }
            System.out.println();
        }
        System.out.println();
    }

    // You don't need to understand the code below here. It is specific to Sudoku.

    private static boolean rowsOk(int[][] board) {
        for (int row = 0; row < N; row++) {
            for (int col1 = 0; col1 < N; col1++) {
                for (int col2 = col1 + 1; col2 < N; col2++) {
                    if (board[row][col1] != 0 && board[row][col1] == board[row][col2]) {
                        return false;
                    }
                }
            }
        }
        return true;
    }
    
    private static boolean columnsOk(int[][] board) {
        for (int col = 0; col < N; col++) {
            for (int row1 = 0; row1 < N; row1++) {
                for (int row2 = row1 + 1; row2 < N; row2++) {
                    if (board[row1][col] != 0 && board[row1][col] == board[row2][col]) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

    private static boolean boxesOk(int[][] board) {
        for (int box = 0; box < N; box++) {
            int boxULRow = (box / K) * K;
            int boxULCol = (box % K) * K;
            for (int i1 = 0; i1 < N; i1++) {
                for (int i2 = i1 + 1; i2 < N; i2++) {
                    if (
                      board[boxULRow + (i1 / K)][boxULCol + (i1 % K)] != 0 && 
                      board[boxULRow + (i1 / K)][boxULCol + (i1 % K)] == 
                      board[boxULRow + (i2 / K)][boxULCol + (i2 % K)]) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

}
